"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Provider = exports.Listen = exports.Controller = void 0;

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _setImmediate2 = _interopRequireDefault(require("@babel/runtime/core-js/set-immediate"));

var _map = _interopRequireDefault(require("@babel/runtime/core-js/map"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _createReactContext = _interopRequireDefault(require("create-react-context"));

var _immer = _interopRequireDefault(require("immer"));

var Context = (0, _createReactContext.default)();
var ListenerID = 0;

var Controller =
/*#__PURE__*/
function () {
  function Controller() {
    var _this = this;

    (0, _classCallCheck2.default)(this, Controller);
    (0, _defineProperty2.default)((0, _defineProperty2.default)(this, "addListener", function (setState, id) {
      if (!_this.map.get(id)) {
        _this.map.set(id, true);

        _this.setFaterState.push({
          fn: setState,
          id: id
        });
      }
    }), "removeListener", function (id) {
      _this.map.delete(id);

      _this.setFaterState = _this.setFaterState.filter(function (i) {
        return i.id !== id;
      });
    });
    this.state = {};
    this.setFaterState = [];
    this.produce = _immer.default;
    this.isDirty = false;
    this.map = new _map.default();
  }

  (0, _createClass2.default)(Controller, [{
    key: "setState",
    value: function setState(partial, cb) {
      var _this2 = this;

      this.isDirty = true;
      (0, _setImmediate2.default)(function () {
        var newState;

        if (typeof partial === 'function') {
          newState = (0, _immer.default)(_this2.state, partial);
        } else {
          newState = (0, _objectSpread2.default)({}, _this2.state, partial);
        }

        _this2.state = newState;
        var callback_length = _this2.setFaterState.length;

        _this2.setFaterState.forEach(function (_ref) {
          var fn = _ref.fn,
              id = _ref.id;
          fn(_this2.state, function () {
            callback_length--;

            if (callback_length <= 0) {
              _this2.isDirty = false;
            }

            cb && cb(_this2.state);
          });
        }); // no matter what `newState` is, we have to set state to original state

      });
    }
  }]);
  return Controller;
}();

exports.Controller = Controller;

var Listen =
/*#__PURE__*/
function (_React$Component) {
  function Listen(props) {
    var _this3;

    (0, _classCallCheck2.default)(this, Listen);
    ListenerID++;
    _this3 = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Listen).call(this, props));
    (0, _defineProperty2.default)((0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this3)), "_noopUpdate", function (state, cb) {
      _this3.setState({}, cb);
    }), "createMachine", function (context) {
      if (context === void 666) {
        throw new Error('<Listen/> components must be wrapped in a <Provider/>');
      }

      var MachineConstructor = _this3.props.to;
      var newMachines = MachineConstructor.map(function (Machine) {
        if (context.get(Machine)) {
          var instance = context.get(Machine);
          instance.addListener(_this3._noopUpdate.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this3))), _this3.id);
          return instance;
        }

        var newInstance = new Machine();
        newInstance.addListener(_this3._noopUpdate.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this3))), _this3.id);
        context.set(Machine, newInstance);
        return newInstance;
      });
      _this3.Machines = newMachines;
      return _this3.Machines;
    });
    _this3.id = ListenerID;
    _this3.state = {};
    _this3.Machines = [];
    _this3._isMounted = false;
    return _this3;
  }

  (0, _createClass2.default)(Listen, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      for (var i in this.Machines) {
        if (this.Machines[i].isDirty === true) {
          return true;
        }
      }

      return false;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this4 = this;

      this.Machines.forEach(function (m) {
        m.removeListener(_this4.id);
      });
      this._isMounted = false;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true;
      this.props.didMount && this.props.didMount.apply(null, this.Machines);
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      return _react.default.createElement(Context.Consumer, null, function (context) {
        return _this5.props.children.apply(null, _this5.createMachine(context));
      });
    }
  }]);
  (0, _inherits2.default)(Listen, _React$Component);
  return Listen;
}(_react.default.Component);

exports.Listen = Listen;

var Provider =
/*#__PURE__*/
function (_React$Component2) {
  function Provider() {
    (0, _classCallCheck2.default)(this, Provider);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Provider).apply(this, arguments));
  }

  (0, _createClass2.default)(Provider, [{
    key: "render",
    value: function render() {
      var _this6 = this;

      return _react.default.createElement(Context.Consumer, null, function (topState) {
        var childState = new _map.default(topState);
        return _react.default.createElement(Context.Provider, {
          value: childState
        }, _this6.props.children);
      });
    }
  }]);
  (0, _inherits2.default)(Provider, _React$Component2);
  return Provider;
}(_react.default.Component);

exports.Provider = Provider;